<?php

namespace Drupal\user_referral\Event;

use Symfony\Component\EventDispatcher\Event;

class UserReferralCookieEvent extends Event {

  const COOKIE_PRE_ASSIGN_LOGIC = 'user_referral.cookie.pre_assign_logic';

  const COOKIE_SET = 'user_referral.cookie.set';

  /**
   * Cookie object.
   *
   * @var \stdClass
   */
  protected $cookie;

  /**
   * Constructs a node insertion demo event object.
   *
   * @param \stdClass $cookie
   */
  public function __construct(\stdClass $cookie) {
    $this->cookie = $cookie;
  }

  /**
   * Get the cookie being set.
   *
   * @return \stdClass
   */
  public function getCookie() {
    return $this->cookie;
  }

  /**
   * Get the cookie being set.
   *
   * @param \stdClass $cookie
   *  Cookie object
   */
  public function setCookie(\stdClass $cookie) {
    $this->cookie = $cookie;
  }
}