<?php

namespace Drupal\user_referral\Event;

use Symfony\Component\EventDispatcher\Event;

class UserReferralReferralEntryEvent extends Event {

  const ENTRY_CREATE = 'user_referral.referral_entry.create';

  /**
   * Entry going to user_referral table row
   *
   * @var array
   */
  protected $entry;

  /**
   * Cookie object.
   *
   * @var \stdClass
   */
  protected $cookie;

  /**
   * Constructs a node insertion demo event object.
   *
   * @param \stdClass $cookie
   */
  public function __construct(array $entry, \stdClass $cookie) {
    $this->entry = $entry;
    $this->cookie = $cookie;
  }

  /**
   * Get the entry being created.
   *
   * @return array
   */
  public function getEntry() {
    return $this->entry;
  }

  /**
   * Set the entry being created.
   *
   * @return array
   */
  public function setEntry(array $entry) {
    $this->entry = $entry;
  }

  /**
   * Get the cookie being set.
   *
   * @return \stdClass
   */
  public function getCookie() {
    return $this->cookie;
  }
}