<?php

namespace Drupal\user_referral\Form;

use Drupal\Core\Entity\EntityDeleteForm;
use Drupal\Core\Form\FormStateInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Drupal\Core\Block\BlockManagerInterface;
use Drupal\Core\Entity\EntityFieldManagerInterface;

/**
 * Provides a form for user referral type deletion.
 *
 * @internal
 */
class UserReferralTypeDeleteConfirm extends EntityDeleteForm {

  /**
   * The entity field manager.
   *
   * @var \Drupal\Core\Entity\EntityFieldManagerInterface
   */
  protected $entityFieldManager;

  /**
   * The Plugin Block Manager.
   *
   * @var \Drupal\Core\Block\BlockManagerInterface
   */
  protected $blockManager;

  /**
   * Constructs the NodeTypeForm object.
   *
   * @param \Drupal\Core\Entity\EntityFieldManagerInterface $entity_field_manager
   *   The entity field manager.
   */
  public function __construct(EntityFieldManagerInterface $entity_field_manager, BlockManagerInterface $block_manager) {
    $this->entityFieldManager = $entity_field_manager;
    $this->blockManager = $block_manager;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('entity_field.manager'),
      $container->get('plugin.manager.block')
    );
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    // TODO: Check existing user referral entries before deleting.
    // $num_nodes = $this->entityTypeManager->getStorage('node')->getQuery()
    //   ->condition('type', $this->entity->id())
    //   ->count()
    //   ->execute();
    // if ($num_nodes) {
    //   $caption = '<p>' . $this->formatPlural($num_nodes, '%type is used by 1 piece of content on your site. You can not remove this content type until you have removed all of the %type content.', '%type is used by @count pieces of content on your site. You may not remove %type until you have removed all of the %type content.', ['%type' => $this->entity->label()]) . '</p>';
    //   $form['#title'] = $this->getQuestion();
    //   $form['description'] = ['#markup' => $caption];
    //   return $form;
    // }

    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    parent::submitForm($form, $form_state);
    $this->entityFieldManager->clearCachedFieldDefinitions();
    $this->blockManager->clearCachedDefinitions();
  }

}
