<?php

namespace Drupal\user_referral\Plugin\Validation\Constraint;

use Symfony\Component\Validator\Constraint;

/**
 * Checks if an entity field has white space characters.
 *
 * @Constraint(
 *   id = "SpaceNotAllowed",
 *   label = @Translation("Space not allowed field constraint", context = "Validation"),
 * )
 */
class SpaceNotAllowedConstraint extends Constraint {

  // public $message = 'A @entity_type with @field_name %value already exists.';
  public $message = '%value contains whitespace characters.';

  /**
   * {@inheritdoc}
   */
  public function validatedBy() {
    return '\Drupal\user_referral\Plugin\Validation\Constraint\SpaceNotAllowedValidator';
  }

}
