<?php

namespace Drupal\user_referral\Plugin\Validation\Constraint;

use Symfony\Component\Validator\Constraint;
use Symfony\Component\Validator\ConstraintValidator;

/**
 * Validates that a field has no white space characters.
 */
class SpaceNotAllowedValidator extends ConstraintValidator {

  /**
   * {@inheritdoc}
   */
  public function validate($items, Constraint $constraint) {
    if (!$item = $items->first()) {
      return;
    }
    $entity = $items->getEntity();
    if (preg_match('/\s/', $item->getValue())) {
      $this->context->addViolation($constraint->message, [
        '%value' => $item->getValue(),
        '@entity_type' => $entity->getEntityType()->getSingularLabel(),
        '@field_name' => mb_strtolower($items->getFieldDefinition()->getLabel()),
      ]);
    }
  }

}
