<?php

namespace Drupal\user_referral\Plugin\Validation\Constraint;

use Symfony\Component\Validator\Constraint;

/**
 * Checks if an entity field has a unique value.
 *
 * @Constraint(
 *   id = "UniqueReferralID",
 *   label = @Translation("Unique field constraint", context = "Validation"),
 * )
 */
class UniqueReferralIDConstraint extends Constraint {

  // public $message = 'A @entity_type with @field_name %value already exists.';
  public $message = 'The referral ID %value already taken.';

  /**
   * {@inheritdoc}
   */
  public function validatedBy() {
    return '\Drupal\user_referral\Plugin\Validation\Constraint\UniqueReferralIDValueValidator';
  }

}
