<?php

namespace Drupal\user_referral\Plugin\views\field;

use Drupal\views\Plugin\views\field\Standard;
use Drupal\views\ResultRow;
use Drupal\user_referral\Entity\UserReferralType as Type;

/**
 * Default implementation of the base field plugin.
 *
 * @ingroup views_field_handlers
 *
 * @ViewsField("user_referral_type")
 */
class UserReferralType extends Standard {

  /**
   * {@inheritdoc}
   */
  public function getEntity(ResultRow $values) {
    $relationship_id = $this->options['relationship'];
    if ($relationship_id == 'none') {
      return $values->_entity;
    }
    elseif (isset($values->_relationship_entities[$relationship_id])) {
      return $values->_relationship_entities[$relationship_id];
    }
  }

  /**
   * {@inheritdoc}
   */
  public function getValue(ResultRow $values, $field = NULL) {
    $alias = isset($field) ? $this->aliases[$field] : $this->field_alias;
    if (isset($values->{$alias})) {
      return Type::load($values->{$alias})->label();
    }
  }

}

