<?php

namespace Drupal\Tests\user_referral\Traits;

use Drupal\Component\Render\FormattableMarkup;
use Drupal\field\Entity\FieldStorageConfig;
use Drupal\field\Entity\FieldConfig;

/**
 * Provides methods to create user referral type from given values.
 *
 * This trait is meant to be used only by test classes.
 */
trait UserRegistrationTrait {

  /**
   * Creates a referral ID field.
   *
   * @param string $field_name
   *   Optional field name
   *
   * @return string
   *   Field name.
   */
  protected function registerUser($edit = NULL) {
    $name = $edit['name'] = $edit['name'] ?? $this->randomMachineName();
    $mail = $edit['mail'] = $edit['mail'] ?? $edit['name'] . '@example.com';
    $this->drupalPostForm('user/register', $edit, t('Create new account'));
    $storage = $this->container
      ->get('entity_type.manager')
      ->getStorage('user');
    $accounts = $storage
      ->loadByProperties([
      'name' => $name,
      'mail' => $mail,
    ]);
    return reset($accounts);
  }

}
